import numpy as np


class WeightsWritter(object):
    def __init__(self, model, is_stored_in_seperated_files):
        self.model = model
        self.num_layers = len(self.model.layers)
        self.is_stored_in_seperated_files = is_stored_in_seperated_files
        self.w_file_name_prefix = "tw_"
        self.b_file_name_prefix = "tb_"
        self.file_name_suffix = ".txt"

    def write_weights(self, file_dir, file_name):
        if self.is_stored_in_seperated_files == False:
            self.write_weights_in_one_files(file_dir, file_name)
        else:
            self.write_weights_in_seperated_files(file_dir)

    def write_weights_in_one_files(self, file_dir, file_name):
        with open(file_dir + file_name, "wt") as f:
            f.writelines(str(self.num_layers) + "\t\n")
            for layer in self.model.layers:
                if(len(layer.get_weights())!=0):
                    weights = layer.get_weights()
                    f.writelines([str(weights[0].shape[0]), "\t", str(weights[0].shape[1]), "\t\n"])
                    [f.writelines([str(b) + "\t" for b in a]) for a in weights[0]]
                    f.writelines("\n")
                    f.writelines([str(weights[1].shape[0]), "\t\n"])
                    f.writelines([str(b) + "\t" for b in weights[1]] + ["\t\n"])

    def write_weights_in_seperated_files(self, file_dir):
        i = 0
        k=0
        for layer in self.model.layers:
            if(len(layer.get_weights())!=0):
                weights = layer.get_weights()
                w_file_name = file_dir + self.w_file_name_prefix + str(k) + self.file_name_suffix
                b_file_name = file_dir + self.b_file_name_prefix + str(k) + self.file_name_suffix
                with open(w_file_name, "wt") as f:
                    np.savetxt(w_file_name, np.transpose(weights[0]))
                with open(b_file_name, "wt") as f:
                    np.savetxt(b_file_name, np.transpose(weights[1]))
                k=k+1
            i=i+1
